*! version 1.0.2 : 29Aug97 : based on discrim.ado by Joseph Hilbe STB-34 smv3.1
*  Delete all cases with missing data in a specified list of variables.

capture program drop markmiss
program define markmiss
    version 4.0
    local if "opt"
    local in "opt"    
    local varlist "ex"
    local options "GENerate(string)"
	parse "`*'"
    tempvar miss touse
    gen `miss' = 0    
	mark `touse' `if' `in'
	parse "`varlist'", parse(" ")
	while "`1'" != ""  {
            capture quietly replace `miss' = 1 if `1'==. & `touse'
            if "`string'" != "" {
            qui capture replace `miss' = 1 /*
             */ if trim(`1') == "" | trim(`1') == "." & `touse'
        }
        mac shift
    }
    di
    if "`generate'" != "" {
        confirm new variable `generate'
        gen `generate' = `miss'
        di in g "Variable " in y "`generate'" in g /*
        */ " indicates missing values for the variables: " in y "`varlist'"
    }
    else {
        di in g "For variables: " in y "`varlist'"
    }        
    di
    qui count if `miss'    
    di in y %8.0f  _result(1) in g " observations with missing values." 
    qui su `miss'
    local pctmiss = round(100*_result(3),1)    
    di in y  %8.1g `pctmiss' in g " percent with missing values."

end
